% capacitance_plot.m, V. Ziemann, 170630
% pkg load instrument-control
close all; clear all
s=serial('/dev/ttyACM0',9600);
sleep(2);
srl_flush(s);
srl_write(s,"CAP?");
sleep(1);
reply=serialReadline(s); 
capacitance=str2double(reply(4:end));
srl_write(s,"TIMESTEP?");
reply=serialReadline(s);
if reply(1:8)=="TIMESTEP"
  timestep=str2double(reply(9:end));
else
  disp(reply)
  close(s);
  return
end
srl_write(s,"WF?");
reply=serialReadline(s);
nsteps=str2num(reply(3:end));
xx=zeros(nsteps,1); 
yy=xx;
for k=1:nsteps
   xx(k)=k*timestep*1e-3;                      % in seconds
   yy(k)=str2double(serialReadline(s))*5/1023; % in Volt
end
close(s)
subplot(2,1,1);
plot(xx,yy);             % raw sensor data
xlabel("Time [s]"); ylabel("Voltage [V]");
title(["Capacitance = " num2str(capacitance) " uF"]);
subplot(2,1,2)
semilogy(xx,yy);
xlabel("Time [s]"); ylabel("log(Voltage)"); 
print('capacitance.png','-S1000,700')
return
% test below
hold on
r=polyfit(xx,log(yy),1)
tau=-1/r(1);
C=tau/33e3
plot(xx,exp(r(2)+r(1).*xx),'r')

[c, fval, info, output] =  fsolve (@(c) (c(2).*exp(-c(1)*xx) - yy), [0, 0]);
C=1/(c(1)*33e3)
