// Webserver to read temperature, V. Ziemann, 161208
#include <ESP8266WiFi.h>
const char* ssid     = "MyHomeNet";
const char* password = ".........";
WiFiServer server(80);  // server listens on html port 80
void setup() {
  pinMode(2,OUTPUT);    // this is pin labelled D4 on nodemcu
  Serial.begin(115200); delay(10);
  Serial.print("Connecting to "); Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500); Serial.print(".");
  }
  Serial.print("\nWiFi connected and ");
  server.begin();
  Serial.print("server started at ");
  Serial.println(WiFi.localIP());
}
void loop() {
  WiFiClient client = server.available();
  while (client) {
    Serial.println("new client");
    while(!client.available()){delay(1);}
    String req = client.readStringUntil('\r');
    Serial.println(req);
    client.flush();
    client.print("HTTP/1.1 200 OK\r\nContent-Type: text/html");
    client.print("\r\n\r\n<!DOCTYPE HTML>\r\n<html>\r\n");
    if (req.indexOf("/gpio2/0") != -1) {
      digitalWrite(2, LOW);
      client.print("GPIO2 is now low");
    } else if (req.indexOf("/gpio2/1") != -1) {
      digitalWrite(2,HIGH);
      client.print("GPIO2 is now high");
    } else if (req.indexOf("/temperature") != -1) {
      float temp=100*3.3*analogRead(0)/1023;
      client.print("Temperature="); client.println(temp,2);
    } else {
      Serial.println("invalid request");
      return;
    }
    client.println("</html>");
    delay(1);
    Serial.println("Client disonnected");
    client.stop();
  }
}

